# -*- coding: utf-8 -*-
# Generated by Django 1.11.23 on 2019-08-25 19:21
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
        ('auth', '0008_alter_user_username_max_length'),
    ]

    operations = [
        migrations.CreateModel(
            name='Activity',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('title', models.CharField(max_length=100)),
                ('kind', models.CharField(choices=[('standard', 'standard'), ('dummy', 'dummy'), ('subflow', 'subflow')], default='standard', max_length=10, verbose_name='type')),
                ('pushapp_param', models.CharField(blank=True, help_text="parameters dictionary; example: {'username':'john'}", max_length=100, null=True)),
                ('app_param', models.CharField(blank=True, help_text="parameters dictionary; example: { 'form_class': 'imovel.form.ContratoLocForm', 'goto': 'contratoLoc'}", max_length=300, null=True, verbose_name='parameters')),
                ('description', models.TextField(blank=True, null=True)),
                ('autostart', models.BooleanField(default=False)),
                ('autofinish', models.BooleanField(default=True)),
                ('sendmail', models.BooleanField(default=True)),
                ('approve', models.BooleanField(default=False, help_text='É atividade de aprovação/rejeição de workflow?', verbose_name='Aprovação')),
                ('ratify', models.BooleanField(default=False, help_text='É atividade de ratificação ou homologação do workflow?', verbose_name='Ratificação')),
                ('join_mode', models.CharField(choices=[('and', 'and'), ('xor', 'xor')], default='xor', max_length=3, verbose_name='join mode')),
                ('split_mode', models.CharField(choices=[('and', 'and'), ('xor', 'xor')], default='and', max_length=3, verbose_name='split mode')),
            ],
            options={
                'verbose_name_plural': 'Activities',
                'verbose_name': 'Activity',
            },
        ),
        migrations.CreateModel(
            name='Application',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('url', models.CharField(help_text='relative to prefix in settings.WF_APPS_PREFIX or URL pattern name', max_length=255, unique=True)),
                ('suffix', models.CharField(blank=True, choices=[('w', 'workitem.id'), ('i', 'instance.id'), ('o', 'object.id')], default='w', help_text='http://[host]/[settings.WF_APPS_PREFIX/][url]/[suffix]', max_length=1, null=True, verbose_name='suffix')),
            ],
        ),
        migrations.CreateModel(
            name='Process',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('enabled', models.BooleanField(default=True)),
                ('date', models.DateTimeField(auto_now=True)),
                ('title', models.CharField(max_length=100)),
                ('description', models.TextField()),
                ('priority', models.IntegerField(choices=[(1, 'Alta'), (2, 'Normal'), (3, 'Baixa')], default=2, verbose_name='Prioridade')),
                ('subject', models.IntegerField(choices=[(1, 'Sistema'), (2, 'Atendimento ao Cliente'), (3, 'Contrato de Administração'), (4, 'Contrato de Locação')], default=2, verbose_name='Função')),
                ('begin', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='bprocess', to='workflow.Activity', verbose_name='initial activity')),
                ('end', models.ForeignKey(blank=True, help_text='a default end activity will be created if blank', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='eprocess', to='workflow.Activity', verbose_name='final activity')),
            ],
            options={
                'verbose_name_plural': 'Processes',
                'permissions': (('can_instantiate', 'Can instantiate'), ('can_browse', 'Can browse')),
            },
        ),
        migrations.CreateModel(
            name='PushApplication',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('url', models.CharField(max_length=255, unique=True)),
            ],
        ),
        migrations.CreateModel(
            name='Transition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('name', models.CharField(blank=True, max_length=50, null=True)),
                ('condition', models.CharField(blank=True, help_text='ex: instance.condition=="OK" | OK', max_length=200, null=True)),
                ('description', models.CharField(blank=True, help_text='Description will be shown on graph', max_length=100, null=True)),
                ('precondition', models.CharField(blank=True, help_text='object method that return True if transition is possible. ex.: obj.is_ok()', max_length=200, null=True)),
                ('input', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='transition_inputs', to='workflow.Activity')),
                ('output', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='transition_outputs', to='workflow.Activity')),
                ('process', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='transitions', to='workflow.Process')),
            ],
        ),
        migrations.CreateModel(
            name='UserProfile',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('web_host', models.CharField(default='localhost:8000', max_length=100)),
                ('notified', models.BooleanField(default=True, verbose_name='notification by email')),
                ('last_notif', models.DateTimeField(default=django.utils.timezone.now)),
                ('nb_wi_notif', models.IntegerField(default=1, help_text='notification if the number of items waiting is reached', verbose_name='items before notification')),
                ('notif_delay', models.IntegerField(default=1, help_text='in days', verbose_name='Notification delay')),
                ('urgent_priority', models.IntegerField(default=5, help_text='a mail notification is sent when an item has at least this priority level', verbose_name='Urgent priority threshold')),
                ('user', models.OneToOneField(on_delete=django.db.models.deletion.PROTECT, to=settings.AUTH_USER_MODEL)),
            ],
            options={
                'verbose_name_plural': 'Workflow users profiles',
                'verbose_name': 'Workflow user profile',
            },
        ),
        migrations.AddField(
            model_name='activity',
            name='application',
            field=models.ForeignKey(blank=True, help_text='leave it blank for prototyping the process without coding', null=True, on_delete=django.db.models.deletion.CASCADE, related_name='activities', to='workflow.Application'),
        ),
        migrations.AddField(
            model_name='activity',
            name='process',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='activities', to='workflow.Process'),
        ),
        migrations.AddField(
            model_name='activity',
            name='push_application',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='push_activities', to='workflow.PushApplication'),
        ),
        migrations.AddField(
            model_name='activity',
            name='roles',
            field=models.ManyToManyField(related_name='activities', to='auth.Group'),
        ),
        migrations.AddField(
            model_name='activity',
            name='subflow',
            field=models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='parent_activities', to='workflow.Process'),
        ),
        migrations.AlterUniqueTogether(
            name='activity',
            unique_together=set([('title', 'process')]),
        ),
    ]
